#!/usr/bin/python
# -*- coding: UTF-8 -*-
import os
import datetime as datetime
import sys
import requests
from datetime import datetime
import hashlib
import json
import uuid

# VMP .Python版<下单示例代码> 
# 公司: eftPay
# 说明： 
# 本示例只是简单编写alipay web下单的示例，
# vmp 所有接口签名方式都一样(vmp eopg除外)，
# 其他场景的下单和查询、退款接口可以跟进文档在本接口的基础上进行相关参数的改变就可以了。
# 日期: 2022-06-06

hosturl="http://vmp.eftpay.com.cn/VMP/Servlet/JSAPIService.do"
#请填写
userkey=""
#请填写
secret=""
currency="HKD"
#请填写
returnUrl = ""
#请填写
notifyUrl = ""
out_trade_no=uuid.uuid4().hex
# 获取当前日期和时间
now = datetime.now()
# 格式化日期字符串
formatted_date = now.strftime("%Y%m%d%H%M%S")

#vmp 下单
def createOrder():
    reqestdata = {
    "service": "service.alipay.web.PreOrder",
    "user_confirm_key": userkey,
    "transaction_amount": "0.02",
    "out_trade_no":out_trade_no,
    "payType":"Alipay",
    "subject":"test subject",
    "wallet":"ALIPAYCN",
    "body":"test body",
    "pay_scene":"WEB",
    "fee_type":currency,
    "notify_url":notifyUrl,
    "return_url":returnUrl,
    "time":formatted_date
    }
    # 按照参数名的ASCII字典序进行排序
    sorted_params = sorted(reqestdata.items(), key=lambda x: x[0])
    # 拼接参数字符串
    param_string = '&'.join([f"{key}={value}" for key, value in sorted_params])
    param_string=secret+param_string
    print("***********param_string")
    print(param_string)
    # 对拼接后的字符串进行SHA-256签名
    sha256_signature = hashlib.sha256(param_string.encode()).hexdigest()
    print("***********sha256_signature:")
    print(sha256_signature)
    reqestdata["sign"]=sha256_signature
    # 将键值对转换为 JSON 数据包
    json_data = json.dumps(reqestdata)
    print("***********json_data:")
    print(json_data)
    # 设置请求头中的 Content-Type
    headers = {'Content-Type': 'application/json'}
    # 发送 POST 请求
    response = requests.post(url=hosturl, data=json_data,timeout=5, headers=headers)
    # 获取响应数据
    response_data = response.json()
    print("***********response:")
    print(response_data)

if __name__ == '__main__':
    print("***************VMP Start*************")
    createOrder()
    print("***************VMP End*************")